CurvyHud = {}

CurvyHud.name 				= 'CurvyHud'
CurvyHud.version 			= "1.1"
CurvyHud.varsVersion		= 2
CurvyHud.varsAccountVersion	= 2

CurvyHud.defaultConfigs 	= {
	[1] = {
		barSpacing				=	0,
		barWidth				=	50,
		barHeight				= 	350,
		hideDefaultTargetFrame 	= 	true,
		hideDefaultPlayerFrame	= 	true,
		combatAlpha 			=	1,
		oocAlpha				=	0.4,
		targetAcquiredAlpha		=	1,
		attributeUsedAlpha		=   1,
		textureConfig			=	'default',
			
		barContainerLeft	= {
			stepOn	= true,
			anchor	= {CENTER,nil,CENTER,-245,0}
		},
	
		barContainerRight	= {
			stepOn 	= true,
			anchor	= {CENTER,nil,CENTER, 245,0}
		},
		
		targetNameplate		= {
			show		= true,
			anchor		= {CENTER,nil,CENTER, 0,-240},
			fontName	= 'Univers 67',
			fontSize	= 20,
			alignment	= TEXT_ALIGN_CENTER,
			classIcon	= true,
			allianceIcon= true,
			rankIcon	= true,
			veteranIcon	= true,
			colorLevel	= 'difficulty',
			colorName	= 'reaction'
		},
		
		interactionPrompt	= {
			anchor	= {CENTER,nil,CENTER, 0,200}
		},
		
		healthBar			= {
			show			= 	true,
			position		= 	'left',
			index			= 	0,
			
			backgroundColor = 	{ 0, 0, 0, 0.7},
			borderColorMax 	=  	{ 1, 1, 1, 1},
			borderColorLow 	=  	{ 1, 1, 1, 1},
			colorMax		= 	{ 130/255, 0, 0, 1},
			colorLow		= 	{ 255/255, 0, 0, 1},
			
			showText 		= 	true,
			textAnchor		=   {CENTER,nil,CENTER,-280,190},
			textColor		=  	{  1, 1, 1, 1},
			textFormat 		= 	'{val} / {max} - {per}%',
			fontName		= 	'Univers 67',
			fontSize		= 	22,
		},
		
		staminaBar			= {
			show			= 	true,
			position		= 	'left',
			index			= 	2,
			
			backgroundColor = 	{ 0, 0, 0, 0.7},
			borderColorMax 	=  	{ 1, 1, 1, 1},
			borderColorLow 	=  	{ 1, 1, 1, 1},
			colorMax		= 	{ 0, 130/255, 0, 1},
			colorLow		= 	{ 0, 255/255, 0, 1},
			
			showText 		= 	true,
			textAnchor  	=   {CENTER,nil,CENTER,-338,140},
			textColor 		=  	{ 1, 1, 1, 1},
			textFormat 		= 	'{val} / {max} - {per}%',
			fontName		= 	'Univers 67',
			fontSize		= 	22,
		},
		
		magickaBar			= {
			show			= 	true,
			position		= 	'left',
			index			= 	1,
			
			backgroundColor = 	{ 0, 0, 0, 0.7},
			borderColorMax 	=  	{ 1, 1, 1, 1},
			borderColorLow 	=  	{ 1, 1, 1, 1},
			colorMax		= 	{ 0, 0, 130/255, 1},
			colorLow		= 	{ 0, 0, 255/255, 1},
			
			showText 		= 	true,
			textAnchor  	=   {CENTER,nil,CENTER,-309,165},
			textColor 		=  	{ 1, 1, 1, 1},
			textFormat 		= 	'{val} / {max} - {per}%',
			fontName		= 	'Univers 67',
			fontSize		= 	22,
		},
		
		targetBar			= {
			show			= 	true,
			position		= 	'right',
			index			= 	0,
			
			backgroundColor = 	{ 0, 0, 0, 0.7},
			borderColorMax 	=  	{ 1, 1, 1, 1},
			borderColorLow 	=  	{ 1, 1, 1, 1},
			colorMax		= 	{ 130/255, 0, 0, 1},
			colorLow		= 	{ 255/255, 0, 0, 1},
			
			showText 		= 	true,
			textAnchor  	=    {CENTER,nil,CENTER,280,190},
			textColor 		=  	{ 1, 1, 1, 1},
			textFormat 		= 	'{per}% - {val} / {max}' ,
			fontName		= 	'Univers 67',
			fontSize		= 	22,
		},
	
		mountBar 			= {
			show			= 	true,
			index			= 	2,
			position		= 	'left',
			
			backgroundColor = 	{ 0, 0, 0, 0},
			borderColorMax 	=  	{ 1, 1, 1, 1},
			borderColorLow 	=  	{ 1, 1, 1, 1},
			colorMax		= 	{ 1, 1, 1, 0.4},
			colorLow		= 	{ 1, 1, 1, 0.4},
			
			showText 		= 	false,
			textAnchor  	=   {CENTER,nil,CENTER,-0,50},
			textColor 		=  	{ 1, 1, 1, 1},
			textFormat 		= 	'{val} / {max} - {per}%',
			fontName		= 	'Univers 67',
			fontSize		= 	22,
		},
		
		werewolfBar 		= {
			show			= 	true,
			index			= 	1,
			position		= 	'left',
			
			backgroundColor = 	{ 0, 0, 0, 0},
			borderColorMax 	=  	{ 1, 1, 1, 1},
			borderColorLow 	=  	{ 1, 1, 1, 1},
			colorMax		= 	{ 1, 1, 1, 0.4},
			colorLow		= 	{ 1, 1, 1, 0.4},
			
			showText 		= 	false,
			textAnchor  	=   {CENTER,nil,CENTER,-0,100},
			textColor 		=  	{ 1, 1, 1, 1},
			textFormat 		= 	'{val} / {max} - {per}%',
			fontName		= 	'Univers 67',
			fontSize		= 	22,
		},
		
		siegeBar 			= {
			show			= 	true,
			index			= 	0,
			position		= 	'left',
			
			backgroundColor = 	{ 0, 0, 0, 0},
			borderColorMax 	=  	{ 1, 1, 1, 1},
			borderColorLow 	=  	{ 1, 1, 1, 1},
			colorMax		= 	{ 1, 1, 1, 0.4},
			colorLow		= 	{ 1, 1, 1, 0.4},
			
			showText 		= 	false,
			textAnchor  	=   {CENTER,nil,CENTER,-0,150},
			textColor 		=  	{ 1, 1, 1, 1},
			textFormat 		= 	'{val} / {max} - {per}%',
			fontName		= 	'Univers 67',
			fontSize		= 	22,
		},
		
		visuals 		= {
			shield	= {
				show			= true,
				color			= {0.2,0,0.8,0.6},
				
				showText		= true,
				textAnchor 		= {CENTER,nil,CENTER,-397,190},
				textColor 		= { 0.6, 0, 1, 1},
				textFormat 		= '(+{val})',
				fontName		= 'Univers 67',
				fontSize		= 22,
			},
			
			regen	= {
				show		= true,
				showBeverage= true,
			},
			
			degen	= {
				show = true,
			},
			
			armorInc= {
				show = true,
			},
			
			armorDec= {
				show = true,
			},
			
			powerInc= {
				show = true,
			},
			
			powerDec= {
				show = true,
			},
			
			poolInc = {
				show = true,
			},
			
			poolDec = {
				show = true,
			},
		},
		
		targetVisuals		= {
			shield	= {
				show			= true,
				color			= {0.2,0,0.8,0.6},
				
				showText		= true,
				textAnchor 		= {CENTER,nil,CENTER,397,190},
				textColor 		= {0.6, 0, 1, 1},
				textFormat 		= '(+{val})',
				fontName		= 'Univers 67',
				fontSize		= 22,
			},
			
			regen	= {
				show		= true,
				showBeverage= true,
			},
			
			degen	= {
				show = true,
			},
			
			armorInc= {
				show = true,
			},
			
			armorDec= {
				show = true,
			},
			
			powerInc= {
				show = true,
			},
			
			powerDec= {
				show = true,
			},
			
			poolInc = {
				show = true,
			},
			
			poolDec = {
				show = true,
			},
		},
	},
}
	
local varsAccountDefaults	= {
	userConfigs = {
	}
}

local varsDefaults = {
	config = CurvyHud.defaultConfigs[1]
}

-- Clean saved vars of unused values
-- more or less buggy i.e. don't work at all.
function  CurvyHud.CleanSavedVars()
	for key,var in pairs(CurvyHud.vars) do
		if(varsDefaults[key] == nil) then
			CurvyHud.vars[key] = nil
		end
	end
	
	for key,var in pairs(CurvyHud.varsAccount) do
		if(varsAccountDefaults[key] == nil) then
			CurvyHud.varsAccount[key] = nil
		end
	end
end

-- Reset saved vars to default values
function  CurvyHud.ResetToDefaults()
	for key , value in pairs( varsDefaults ) do
		CurvyHud.vars[key] = varsDefaults[key]
	end
	for key , value in pairs( varsAccountDefaults ) do
		CurvyHud.varsAccount[key] = varsAccountDefaults[key]
	end
end

-- Get the appropriate localization table
function CurvyHud:GetLoc()
	if(GetCVar('language.2') == 'fr') then
		return CurvyHud.Loc_FR
	elseif(GetCVar('language.2') == 'de')  then
		return CurvyHud.Loc_EN
	else
		return CurvyHud.Loc_EN
	end
end

function CurvyHud:OnLoaded(event, addonName)
	if (addonName ~= self.name) then return end
	
	-- unregistering from EVENT_ADD_ON_LOADED cause we don't need it anymore
	EVENT_MANAGER:UnregisterForEvent(self.name, EVENT_ADD_ON_LOADED)	
	
	-- Loading saved vars
	self.varsAccount = ZO_SavedVars:NewAccountWide('CurvyHudData', self.varsAccountVersion, nil, varsAccountDefaults)
	self.vars = ZO_SavedVars:New('CurvyHudData', self.varsVersion	, nil, varsDefaults)
	
	-- loading configuration from saved vars
	self.config = self.vars.config
	
	-- Initializing some basic tables
	self.bars 				= {}
	self.state 				= {}
	self.movableFrames 		= {}
	
	-- Initializing move mode state
	self.moveMode = {}
	self.moveMode.enabled = false
	
	-- Initializing everything else
	self:InitializeVisuals()
	self:InitializeControls()	
	self:InitializeState()
	self:InitializeMoveMode()
	self:InitializeMenu()
	

	-- registering events
	EVENT_MANAGER:RegisterForEvent('CurvyHud', EVENT_RETICLE_TARGET_CHANGED			,CurvyHud.OnTargetChanged)
	EVENT_MANAGER:RegisterForEvent('CurvyHud', EVENT_RETICLE_HIDDEN_UPDATE			,CurvyHud.OnReticleHidden)
	EVENT_MANAGER:RegisterForEvent('CurvyHud', EVENT_POWER_UPDATE					,CurvyHud.OnPowerUpdated)
	EVENT_MANAGER:RegisterForEvent('CurvyHud', EVENT_PLAYER_COMBAT_STATE			,CurvyHud.OnCombatStateChanged)
	EVENT_MANAGER:RegisterForEvent('CurvyHud', EVENT_MOUNTED_STATE_CHANGED			,CurvyHud.OnMountedStateChanged)
	EVENT_MANAGER:RegisterForEvent('CurvyHud', EVENT_PLAYER_DEAD					,CurvyHud.OnPlayerDead)
	EVENT_MANAGER:RegisterForEvent('CurvyHud', EVENT_PLAYER_ALIVE					,CurvyHud.OnPlayerAlive)
	EVENT_MANAGER:RegisterForEvent('CurvyHud', EVENT_WEREWOLF_STATE_CHANGED			,CurvyHud.OnWerewolfStateChanged)
	EVENT_MANAGER:RegisterForEvent('CurvyHud', EVENT_BEGIN_SIEGE_CONTROL			,CurvyHud.OnSiegeStateChanged)
	EVENT_MANAGER:RegisterForEvent('CurvyHud', EVENT_END_SIEGE_CONTROL				,CurvyHud.OnSiegeStateChanged)
	EVENT_MANAGER:RegisterForEvent('CurvyHud', EVENT_UNIT_ATTRIBUTE_VISUAL_ADDED	,CurvyHud.OnVisualChanged)
	EVENT_MANAGER:RegisterForEvent('CurvyHud', EVENT_UNIT_ATTRIBUTE_VISUAL_REMOVED	,CurvyHud.OnVisualChanged)
	EVENT_MANAGER:RegisterForEvent('CurvyHud', EVENT_UNIT_ATTRIBUTE_VISUAL_UPDATED	,CurvyHud.OnVisualChanged)
	-- EVENT_MANAGER:RegisterForEvent('CurvyHud', EVENT_PLAYER_ACTIVATED, CurvyHud.OnPlayerActivated) TODO handle this
end

EVENT_MANAGER:RegisterForEvent('CurvyHud', EVENT_ADD_ON_LOADED,function(...) CurvyHud:OnLoaded(...) end)