--------------------------------------------------
-- /Visuals/Visuals.lua							--
-- Contains functions which manage all visuals	--
--------------------------------------------------

local L = CurvyHud:GetLoc()


function CurvyHud:InitializeVisuals()
	self.visuals = {}
	self.targetVisuals = {}
	
	self.visuals.shield	= {}
	self.visuals.shield.on = false
	self.visuals.shield.value = 0
	
	-- self.visuals.regenBeverage = {
		-- ['healthBar']	= false,
		-- ['magickaBar']	= false,
		-- ['staminaBar']	= false
	-- }
	
	self.visuals.regen = {
		['healthBar']	= false,
		['magickaBar']	= false,
		['staminaBar']	= false
	}
	
	self.visuals.degen = {
		['healthBar']	= false,
		['magickaBar']	= false,
		['staminaBar']	= false
	}
	
	self.targetVisuals.shield	= {}
	self.targetVisuals.shield.on = false
	self.targetVisuals.shield.value = 0
	
	self.targetVisuals.regen = false
	self.targetVisuals.degen = false
	
end


function CurvyHud:UpdatePlayerVisual(visualOn,unitAttributeVisual,statType,powerType,value,maxValue)

	local visualsCfg = self.config.visuals
	-- getting primary attributes values
	local health = {GetUnitPower('player',self.barPowertypeMapping['healthBar'])}
	local stamina = {GetUnitPower('player',self.barPowertypeMapping['staminaBar'])}
	local magicka = {GetUnitPower('player',self.barPowertypeMapping['magickaBar'])}

	-- SHIELD BUFF
	if(unitAttributeVisual == ATTRIBUTE_VISUAL_POWER_SHIELDING) then
		if((visualsCfg.shield.show and self.config.healthBar.show)
		or (visualsCfg.shield.showText and self.config.healthBar.showText)) then
			if(visualOn and value ~= nil and value > 0) then
				self.visuals.shield.value = value
				self.bars.healthBar.shield:SetHidden(false)
				self.visuals.shield.on = true
			else
				self.visuals.shield.value = 0
				self.bars.healthBar.shield:SetHidden(true)
				self.visuals.shield.on = false
			end
			
			if(visualsCfg.shield.show and self.config.healthBar.show) then
				self:UpdateBar('healthBar', health[1],health[3],visualOn)
			end
			
			
			if(visualsCfg.shield.showText and self.config.healthBar.showText) then
				self:UpdateTextValues('healthBar',health[1],health[3])
			end
			
			self:FadePlayerBar('healthBar',health[1],health[3])
		end
	-- ARMOR BUFF/DEBUFF
	elseif(statType == STAT_ARMOR_RATING and self.config.healthBar.show) then
		-- if(unitAttributeVisual == ATTRIBUTE_VISUAL_INCREASED_STAT and visualOn and value > 0) then
			-- self.visuals.armorInc= true
			-- self.bars.healthBar.armorInc:SetHidden(false)
		-- elseif (unitAttributeVisual == ATTRIBUTE_VISUAL_DECREASED_STAT and visualOn and value > 0) then
			-- self.visuals.armorDec = true
			-- self.bars.healthBar.armorDec:SetHidden(false)
		-- else
			-- self.visuals.armorDec = false
			-- self.bars.healthBar.armorDec:SetHidden(true)
			-- self.visuals.armorInc= false
			-- self.bars.healthBar.armorInc:SetHidden(true)
		-- end
	-- REGEN
	elseif(unitAttributeVisual == ATTRIBUTE_VISUAL_INCREASED_REGEN_POWER) then
		local barName = self.statTypeBarMapping[statType]
		if(self.config[barName].show and visualsCfg.regen.show) then
			local regenCtrl = self.bars[barName].regen
			
			if( value ~= nil and maxValue ~= nil and maxValue ~= 0 and value ~= 0 and visualOn) then
				-- if(self:IsBeverageOn(barName)) then 
				-- -- it means either
					-- -- we just added a beverage buff without another regen on 
					-- if(not self.visuals.regen[barName] and not self.visuals.regenBeverage[barName]) then
						-- -- -- OOOOOOOK display beverage regen
						-- self.visuals.regen[barName] = false
						-- self.visuals.regenBeverage[barName] = true
						-- regenCtrl.anim:SetLoopOffset(1500)
						-- regenCtrl.anim.lastUpdate = nil
					-- else
						-- self.visuals.regen[barName] = true
						-- self.visuals.regenBeverage[barName] = true
						-- regenCtrl.anim:SetLoopOffset(0)
						-- regenCtrl.anim.lastUpdate = GetGameTimeMilliseconds()
						
					-- OLD but insightful
					-- -- we just added a beverage buff while another regen is on
					-- elseif(self.visuals.regen[barName] and not self.visuals.regenBeverage[barName]) then
						-- -- OOOOOOOK display normal regen
						-- self.visuals.regen[barName] = true
						-- self.visuals.regenBeverage[barName] = true

					-- -- we added any regen while beverage buff is on
					-- elseif(not self.visuals.regen[barName] and self.visuals.regenBeverage[barName]) then
						-- OOOOOOOK display normal regen
						-- self.visuals.regen[barName] = true
						-- self.visuals.regenBeverage[barName] = true
					-- we updated any regen while beverage buff is on
					-- OR we removed all 'normal' regen but beverage buff <-- THIS is hard to check
					-- elseif(self.visuals.regen[barName] and self.visuals.regenBeverage[barName]) then
						-- OOOOOOOK display normal regen
						-- self.visuals.regen[barName] = true
						-- self.visuals.regenBeverage[barName] = true					
					-- end
				-- else -- beverage is not on
				-- -- it means either
					-- -- we just removed a beverage buff while another regen is on
						-- -- OOOOOOOK display normal regen
					-- -- we added or updated any regen with no beverage buff on
						-- -- OOOOOOOK display normal regen
					self.visuals.regen[barName] = true
					-- self.visuals.regenBeverage[barName] = false
					-- regenCtrl.anim:SetLoopOffset(0)
					-- regenCtrl.anim.lastUpdate = nil
				-- end
				
				-- showing the regen control
				regenCtrl:SetHidden(false)
				
				-- playing the animation if it's not already playing
				if(not regenCtrl.timeline:IsPlaying()) then
					regenCtrl.timeline:PlayFromStart()
				else
					regenCtrl.timeline:SetPlaybackLoopsRemaining(100000)
				end
			else
				self.visuals.regen[barName] = false
				-- self.visuals.regenBeverage[barName] = false
				regenCtrl.timeline:SetPlaybackLoopsRemaining(0)
			end
			-- self:FadePlayerBar(barName)
		end
	elseif(unitAttributeVisual == ATTRIBUTE_VISUAL_DECREASED_REGEN_POWER) then
		local barName = self.statTypeBarMapping[statType]
		if(self.config[barName].show and visualsCfg.degen.show) then
			local degenCtrl = self.bars[barName].degen
			
			if( value ~= nil and maxValue ~= nil and visualOn) then
				self.visuals.degen[barName] = true
				-- showing the degen control
				degenCtrl:SetHidden(false)
				
				-- playing the animation if it's not already playing
				if(not degenCtrl.timeline:IsPlaying()) then
					degenCtrl.timeline:PlayFromStart()
				else
					degenCtrl.timeline:SetPlaybackLoopsRemaining(100000)
				end
			else
				self.visuals.degen[barName] = false
				-- self.visuals.regenBeverage[barName] = false
				degenCtrl.timeline:SetPlaybackLoopsRemaining(0)
			end
			-- self:FadePlayerBar(barName)
		end
	end
end

function CurvyHud:UpdateTargetVisual(visualOn,unitAttributeVisual,statType,powerType,value,maxValue)
	local visualsCfg = self.config.targetVisuals
	-- getting primary attributes values
	local health = {GetUnitPower('reticleover',POWERTYPE_HEALTH)}
	
	-- SHIELD BUFF
	if(unitAttributeVisual == ATTRIBUTE_VISUAL_POWER_SHIELDING) then
		if((visualsCfg.shield.show and self.config.targetBar.show)
		or (visualsCfg.shield.showText and self.config.targetBar.showText)) then
			if(visualOn and value ~= nil and value > 0) then
				self.targetVisuals.shield.value = value
				self.bars.targetBar.shield:SetHidden(false)
				self.targetVisuals.shield.on = true
			else
				self.targetVisuals.shield.value = 0
				self.bars.targetBar.shield:SetHidden(true)
				self.targetVisuals.shield.on = false
			end
			
			if(visualsCfg.shield.show and self.config.targetBar.show) then
				self:UpdateBar('targetBar', health[1],health[3],visualOn)
			end
			
			
			if(visualsCfg.shield.showText and self.config.targetBar.showText) then
				self:UpdateTextValues('targetBar',health[1],health[3])
			end
			
			self:FadeTargetBar()
		end
	elseif(unitAttributeVisual == ATTRIBUTE_VISUAL_INCREASED_REGEN_POWER and statType == STAT_HEALTH_REGEN_COMBAT) then
		if(self.config.targetBar.show and visualsCfg.regen.show) then
			local regenCtrl = self.bars.targetBar.regen
			
			if( value ~= nil and maxValue ~= nil and maxValue ~= 0 and value ~= 0 and visualOn) then
				self.targetVisuals.regen = true
					
				-- showing the regen control
				regenCtrl:SetHidden(false)
				
				-- playing the animation if it's not already playing
				if(not regenCtrl.timeline:IsPlaying()) then
					regenCtrl.timeline:PlayFromStart()
				else
					regenCtrl.timeline:SetPlaybackLoopsRemaining(100000)
				end
			else
				self.targetVisuals.regen = false
				regenCtrl.timeline:SetPlaybackLoopsRemaining(0)
			end
		end
	elseif(unitAttributeVisual == ATTRIBUTE_VISUAL_DECREASED_REGEN_POWER) then
		if(self.config.targetBar.show and visualsCfg.degen.show) then
			local degenCtrl = self.bars.targetBar.degen
			
			if( value ~= nil and maxValue ~= nil and visualOn) then
				self.targetVisuals.degen = true
				-- showing the degen control
				degenCtrl:SetHidden(false)
				
				-- playing the animation if it's not already playing
				if(not degenCtrl.timeline:IsPlaying()) then
					degenCtrl.timeline:PlayFromStart()
				else
					degenCtrl.timeline:SetPlaybackLoopsRemaining(100000)
				end
			else
				self.targetVisuals.degen = false
				degenCtrl.timeline:SetPlaybackLoopsRemaining(0)
			end
			-- self:FadePlayerBar(barName)
		end
	end
end

function CurvyHud:ResetTargetVisuals()
	
	-- resetting shield
	self.targetVisuals.shield.on = false
	self.targetVisuals.shield.value = 0
	self.bars.targetBar.shield:SetHidden(true)
	self.bars.targetBar.shield.textContainer.text:SetHidden(true)
	
	-- resetting regen
	self.targetVisuals.regen = false
	self.bars.targetBar.regen:SetHidden(true)
	self.bars.targetBar.regen.timeline:Stop()
	
	-- resetting degen
	self.targetVisuals.degen = false
	self.bars.targetBar.degen:SetHidden(true)
	self.bars.targetBar.degen.timeline:Stop()
end

-- function CurvyHud:IsBeverageOn(barName)
	-- local unit = 'player'
	-- if(barName == 'targetBar') then unit = 'reticleover' end
	-- for i =1, GetNumBuffs(unit) do
		-- local name = GetUnitBuffInfo(unit,i)
		-- if( name == self.beverageBuffs[barName][1] or name == self.beverageBuffs[barName][2] or name == self.beverageBuffs[barName][3] or name == self.beverageBuffs[barName][4]) then
			-- return true
		-- end
	-- end
	
	-- return false
-- end

-- CurvyHud.beverageBuffs = {
	-- ["healthBar"] 	= {L.H_Beverage, L.HM_Beverage, L.HS_Beverage, L.HMS_Beverage},
	-- ["staminaBar"] 	= {L.S_Beverage, L.MS_Beverage, L.HS_Beverage, L.HMS_Beverage},
	-- ["magickaBar"] 	= {L.M_Beverage, L.HM_Beverage, L.MS_Beverage, L.HMS_Beverage},
	-- ["targetBar"] 	= {L.H_Beverage, L.HM_Beverage, L.HS_Beverage, L.HMS_Beverage}
-- }